﻿Imports System.Runtime.CompilerServices
Imports System.ComponentModel
Imports System.Data.Common

Namespace System.Data

   Public Module DataX

#Region "ConnectionOpening"
      Private _ConnectionWatchers As New ComponentProperty(Of DbConnection, ConditionalActionFrame)(AddressOf CreateActionFrame)


      Private Function CreateActionFrame(ByVal conn As DbConnection) As ConditionalActionFrame
         Return New ConditionalActionFrame(Function() conn.State = ConnectionState.Closed, AddressOf conn.Open, AddressOf conn.Close)
      End Function

      <System.Runtime.CompilerServices.Extension()> _
      Public Function EnterOpen(ByVal conn As DbConnection) As IDisposable
         Return _ConnectionWatchers(conn).Enter()
      End Function

#End Region 'ConnectionOpening

#Region "Data.Common-Objekte klonen"

      ' Die Basisklassen DbCommand + DbParameter sind gar snicht Cloneable, aber die Erben für OLE, Obc,SqlServer sinds, und deshalb geht das
      <System.Runtime.CompilerServices.Extension()> _
      Public Function Clone(ByVal cmd As DbCommand) As DbCommand
         Return DirectCast(DirectCast(cmd, ICloneable).Clone(), DbCommand)
      End Function
      <System.Runtime.CompilerServices.Extension()> _
      Public Function Clone(ByVal param As DbParameter) As DbParameter
         Return DirectCast(DirectCast(param, ICloneable).Clone(), DbParameter)
      End Function
#End Region

      <Extension()> _
      Public Sub CopyTo(Of T As DataRow)(ByVal subj As T, ByVal other As T)
         Dim itms = subj.ItemArray
         If other.RowState <> DataRowState.Detached Then
            Dim tb = other.Table
            For Each indx In tb.PrimaryKey.Select(Function(cl) cl.Ordinal)
               itms(indx) = other(indx)
            Next
         End If
         other.ItemArray = itms
      End Sub

      '<System.Diagnostics.DebuggerStepThrough()> _
      '<Extension()> _
      'Public Function AddNewX(Of T)(ByVal subj As IBindingList) As T
      '   Return DirectCast(subj.AddNew, T)
      'End Function

      '<System.Diagnostics.DebuggerStepThrough()> _
      '<Extension()> _
      'Public Function AddNewX(Of T As DataRow)(ByVal subj As BindingSource) As T
      '   Return DirectCast(DirectCast(subj.AddNew, DataRowView).Row, T)
      'End Function

   End Module
End Namespace
