﻿Public Module wasserzeichenExtension
   Private _allregisteredTextboxesWithWatermarks As New List(Of WTM_object)
   <Runtime.CompilerServices.Extension()>
   Sub createWatermark(ByVal tb As TextBox, ByVal wasserzeichen As String)
      Dim bereitsvorhanden As Boolean = False
      For Each obj_ausderliste In _allregisteredTextboxesWithWatermarks
         If obj_ausderliste.usedtextbox Is tb Then
            bereitsvorhanden = True
         End If
      Next
      If bereitsvorhanden = False Then
         AddHandler tb.GotFocus, AddressOf wasserzeichen_textbox_GotFocus
         AddHandler tb.LostFocus, AddressOf wasserzeichen_textbox_LostFocus
         _allregisteredTextboxesWithWatermarks.Add(
                         New WTM_object With {.usedtextbox = tb,
                                              .wasserzeichen = wasserzeichen,
                                              .actualfont = tb.Font,
                                              .backcolor = tb.BackColor,
                                              .forecolor = tb.ForeColor,
                                              .textalign = tb.TextAlign,
                                              .usepwchar = tb.UseSystemPasswordChar})
         wasserzeichen_textbox_LostFocus(tb, Nothing)
      Else 'if bereitsvorhanden = True
         Throw New Exception("Der Textbox '" & tb.Name & "' ist bereits ein wasserzeichen zugeordnet")
      End If
   End Sub
   <System.Runtime.CompilerServices.Extension()>
   Sub removeWatermark(ByVal tb As TextBox)
      For Each element_ausderliste In _allregisteredTextboxesWithWatermarks
         If element_ausderliste.usedtextbox Is tb Then
            wasserzeichen_textbox_GotFocus(tb, Nothing)
            RemoveHandler tb.GotFocus,
                        AddressOf wasserzeichen_textbox_GotFocus
            RemoveHandler tb.LostFocus,
                        AddressOf wasserzeichen_textbox_LostFocus
            _allregisteredTextboxesWithWatermarks.Remove(element_ausderliste)
            Exit For
         End If
      Next
   End Sub
   Sub removeallWatermarks()
      For q = _allregisteredTextboxesWithWatermarks.Count - 1 To 0 Step -1
         removeWatermark(_allregisteredTextboxesWithWatermarks(q).usedtextbox)
      Next
   End Sub
   Private Sub wasserzeichen_textbox_GotFocus(ByVal sender As Object, ByVal e As EventArgs)
      Dim tb_sender = CType(sender, TextBox)
      For Each aktuelle_standards In _allregisteredTextboxesWithWatermarks
         If tb_sender Is aktuelle_standards.usedtextbox Then
            If aktuelle_standards.effectisapplied Then
               With tb_sender
                  RemoveHandler .GotFocus,
                          AddressOf wasserzeichen_textbox_GotFocus
                  RemoveHandler .LostFocus,
                          AddressOf wasserzeichen_textbox_LostFocus
                  .Font = aktuelle_standards.actualfont
                  .Text = Nothing
                  .ForeColor = aktuelle_standards.forecolor
                  .BackColor = aktuelle_standards.backcolor
                  .TextAlign = aktuelle_standards.textalign
                  .UseSystemPasswordChar = aktuelle_standards.usepwchar
                  AddHandler .GotFocus,
                          AddressOf wasserzeichen_textbox_GotFocus
                  AddHandler .LostFocus,
                          AddressOf wasserzeichen_textbox_LostFocus
               End With
               aktuelle_standards.effectisapplied = False
            End If
            Exit For
         End If
      Next
   End Sub
   Private Sub wasserzeichen_textbox_LostFocus(ByVal sender As Object, ByVal e As EventArgs)
      Dim tb_sender = CType(sender, TextBox)
      For Each element In _allregisteredTextboxesWithWatermarks
         If tb_sender Is element.usedtextbox Then
            If tb_sender.Text = Nothing Then
               With tb_sender
                  .Text = element.wasserzeichen
                  .Font = New Font(.Font,
                                   FontStyle.Italic)
                  .BackColor = Color.FromKnownColor(KnownColor.Info)
                  .ForeColor = Color.Gray
                  .TextAlign = HorizontalAlignment.Left
                  .UseSystemPasswordChar = False
               End With
               element.effectisapplied = True
            End If
            Exit For
         End If
      Next
   End Sub
   Friend Class WTM_object
      Friend effectisapplied As Boolean
      Friend usedtextbox As TextBox
      Friend wasserzeichen As String
      Friend actualfont As Font
      Friend forecolor As Color
      Friend backcolor As Color
      Friend textalign As HorizontalAlignment
      Friend usepwchar As Boolean
   End Class
End Module
