﻿Imports System.IO
Imports System.ComponentModel

Namespace System.Data

   Public Class DatasetXmlAdapter : Inherits DatasetAdapterBase

      Public ReadOnly DataFile As FileInfo

      Public Sub New(ByVal _Dts As DataSet, ByVal path As String)
         DataFile = New FileInfo(path)
         DataSet = _Dts
      End Sub

      Public Sub Fill()
         DataSet.Clear()
         Dim fi As FileInfo = DataFile
         If fi.Exists() Then
            Dim tbls = DataSet.GetRankedTables
            For Each tb As DataTable In tbls
               tb.BeginLoadData()
            Next
            DataSet.ReadXml(fi.FullName)
            For i = tbls.Count - 1 To 0 Step -1
               tbls(i).EndLoadData()
            Next
         Else
            MsgBox(String.Concat( _
               "Leider (noch) kein DatenFile vorhanden", ControlChars.Lf, _
               "Sie können aber trotzdem fortfahren, und eines anlegen."))
         End If
         DataSet.AcceptChanges()
      End Sub

      Protected Overrides Sub _Save(ByVal tbls As List(Of DataTable))
         DataSet.WriteXml(DataFile.FullName)
         DataSet.AcceptChanges()
      End Sub

   End Class

End Namespace