﻿Imports System.ComponentModel

Partial Class GrKassDts
   Partial Class AutoVorgangDataTable
      'hält eine Liste mit Strings, die als AutoCompleteSource in DatagridViewTextboxColumns verwendet wird. Das vermindert die Schreibarbeit beim Eingaben von Vorgängen

      Public ReadOnly Completions As New AutoCompleteStringCollection

      ''' <summary>
      ''' falls der e.ProposedValue einen AutoCompletion-Eintrag matcht,
      ''' deren Gross/Klein-Schreibung übernehmen
      ''' </summary>
      Public Sub ProposeValue(ByVal e As DataColumnChangeEventArgs)
         Dim s = e.ProposedValue.ToString.ToLower
         For Each s2 As String In Completions
            If s2.ToLower = s Then e.ProposedValue = s2 : Return
         Next
      End Sub

      Private Sub AutoVorgangDataTable_AutoVorgangRowChanging(ByVal sender As Object, ByVal e As AutoVorgangRowChangeEvent) Handles Me.AutoVorgangRowChanging
         ' AutoCompleteStringCollection synchronisieren
         Dim ilist = DirectCast(Me, IListSource).GetList
         Select Case e.Action
            Case DataRowAction.Add
               Completions.Add(e.Row.Text)
            Case DataRowAction.Change
               Completions(ilist.IndexOf(e.Row)) = e.Row.Text
            Case DataRowAction.Delete
               Completions.RemoveAt(ilist.IndexOf(e.Row))
         End Select
      End Sub
   End Class
End Class
