﻿Imports System.ComponentModel
Imports System.Text

Partial Class GrKassDts

   Partial Class BelegDataTable

      Public Sub BelegDataTable_ColumnChanged(ByVal sender As Object, ByVal e As DataColumnChangeEventArgs)
         If e.Column Is columnBetrag Then e.Row.CastX(Of BelegRow).Recalculate()
      End Sub

      Public Sub Row_Deleted(ByVal sender As Object, ByVal e As BelegRowChangeEvent) Handles Me.BelegRowDeleted
         'komischer Bug: sonst meldet das Dataset .HasErrors - obwohl die Row doch weg ist.
         e.Row.ClearErrors()
         With Me.Dts.Posten
            AddHandler .PostenRowDeleted, AddressOf .Row_Deleted
         End With
      End Sub

      Private Sub Column_Changing(ByVal sender As Object, ByVal e As DataColumnChangeEventArgs) Handles Me.ColumnChanging
         If e.Column Is columnVorgang Then Me.Dts.AutoVorgang.ProposeValue(e)
      End Sub

      Private Sub BelegDataTable_RowDeleting(ByVal sender As Object, ByVal e As System.Data.DataRowChangeEventArgs) Handles Me.RowDeleting
         With Me.Dts.Posten
            RemoveHandler .PostenRowDeleted, AddressOf .Row_Deleted
         End With
      End Sub

      Private Sub Table_NewRow(ByVal sender As Object, ByVal e As DataTableNewRowEventArgs) Handles Me.TableNewRow
         'das Datum der zuletzt geaddeten row als DefaultValue, eigenes AutoIncrement mit weniger Lücken
         Dim rw = DirectCast(e.Row, BelegRow)
         With Me.DefaultView
            If .Count = 0 Then
               rw.Datum = Date.Today
               rw.BelegID = 0
            Else
               Dim last = .At(Of BelegRow)(.Count - 1)
               rw.Datum = last.Datum
               rw.BelegID = last.BelegID + 1
            End If
         End With
      End Sub

   End Class

   Partial Class BelegRow

      Public Sub Recalculate()
         'Dbg(" Recalculate")
         Dim fixedSum = 0D
         Dim unfixeds As New List(Of PostenRow)
         For Each p In GetPostenRows()
            If p.Vorgang = "" Then
               If p.IstAnteil Then
                  unfixeds.Add(p)
               Else
                  If p.Betrag <> 0D Then p.Betrag = 0D
               End If
            Else
               fixedSum += p.Betrag
            End If
         Next
         If HasErrors Then ClearErrors()
         If unfixeds.Count = 0 Then
            If fixedSum <> Betrag Then RowError = "Aufteilung fehlerhaft: Mindestens eine Kasse sollte bei 'Gleiche Aufteilung' angeklickt sein - sonst kann keine Aufteilung des Beleges berechnet werden."
         Else
            SplitMonney(Betrag - fixedSum, unfixeds)
         End If
      End Sub

      Private Sub SplitMonney(ByVal amount As Decimal, ByVal unfixeds As List(Of PostenRow))
         'aufgrund einer heute eigentlich unzeitgemäßen Tradition dürfen Geldbeträge nicht in kleinere Einheiten als 1/100€ aufgeteilt werden.
         Dim dts = DirectCast(Table.DataSet, GrKassDts)
         Using dts.AufteilEventDisabler.Enter()
            Dim first = unfixeds(0)
            Dim aufteilDisplay = first.BelegRow Is first.KasseRow.BelegRow
            If aufteilDisplay Then dts.Kasse.ForEach(Sub(k) k.ClearAnteil())
            Dim rest = CType(amount * 100, Integer)
            Dim result = Math.DivRem(rest, unfixeds.Count, rest) / 100D 'rest byref!!
            Dim resultPlus = result + 0.01D
            If rest < 0 Then
               resultPlus = result - 0.01D
               rest = -rest
            End If
            For i = 0 To unfixeds.Count - 1
               Dim a = If(i < rest, resultPlus, result)
               With unfixeds(i)
                  If .Betrag <> a Then .Betrag = a
                  If aufteilDisplay Then .KasseRow.SetAnteil(a)
               End With
            Next
         End Using
      End Sub

   End Class

End Class
