﻿Imports System.ComponentModel
Imports System.Runtime.CompilerServices
Imports System.Text

Public Module DatasetX
   'recht unsauber, aber ich bins leid, innerhalb der BusinessLogic immer auf GrKassDts zu casten
   <Extension()> _
   Function SuspendLogic(ByVal dts As DataSet) As IDisposable
      Return DirectCast(dts, GrKassDts).AufteilEventDisabler.Enter
   End Function
   <Extension()> _
   Function Dts(ByVal tb As DataTable) As GrKassDts
      Return DirectCast(tb.DataSet, GrKassDts)
   End Function
   <Extension()> _
   Function Dts(ByVal rw As DataRow) As GrKassDts
      Return DirectCast(rw.Table.DataSet, GrKassDts)
   End Function
End Module
Partial Class GrKassDts

   'an der automatischen Berechnung der Posten sind 3 Tables beteiligt: Beleg, Posten, und eigens dafür entworfene temporäre Spalten der KasseDataTable. Das Aufteil-Gui zeigt nämlich die temp-Spalten aller KasseRows an. So kann man bequem reinklicken, um zu bestimmen, welche Kasse am Beleg beteiligt werden soll. In dem Fall wird eine PostenRow generiert, und die Aufteilung neu berechnet. Ebenfalls neu berechnet wird, wenn der Betrag des Beleges oder eines Postens sich ändert, oder ein Posten gelöscht/geadded wird
   'während der Recalculation müssen diverse Events abhängbar sein
   Public AufteilEventDisabler As New ActionFrame( _
      Sub()
         RemoveHandler Kasse.ColumnChanging, AddressOf Kasse.Column_Changing
         RemoveHandler Beleg.ColumnChanged, AddressOf Beleg.BelegDataTable_ColumnChanged
         'RemoveHandler Beleg.BelegRowDeleted, AddressOf Beleg.Row_Deleted
         RemoveHandler Posten.ColumnChanging, AddressOf Posten.Column_Changing
         RemoveHandler Posten.ColumnChanged, AddressOf Posten.Column_Changed
         RemoveHandler Posten.PostenRowChanged, AddressOf Posten.Row_Changed
         RemoveHandler Posten.PostenRowDeleted, AddressOf Posten.Row_Deleted
      End Sub, _
      Sub()
         AddHandler Kasse.ColumnChanging, AddressOf Kasse.Column_Changing
         AddHandler Beleg.ColumnChanged, AddressOf Beleg.BelegDataTable_ColumnChanged
         'AddHandler Beleg.BelegRowDeleted, AddressOf Beleg.Row_Deleted
         AddHandler Posten.ColumnChanging, AddressOf Posten.Column_Changing
         AddHandler Posten.ColumnChanged, AddressOf Posten.Column_Changed
         AddHandler Posten.PostenRowChanged, AddressOf Posten.Row_Changed
         AddHandler Posten.PostenRowDeleted, AddressOf Posten.Row_Deleted
      End Sub)

   Public Shadows Function HasChanges() As Boolean
      'die temporären Kasse-Columns werden natürlich andauernd geändert, aber das hat für die Persistenz keine Bedeutung. Daher für KasseDataTable eine spezielle HasChanges-Ermittlung
      If Kasse.Any(Function(k) k.SignificantHash <> k.CalculateSignificantHash()) Then Return True
      Kasse.AcceptChanges()
      Return MyBase.HasChanges
   End Function

   Private Sub GrKassDts_Initialized(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Initialized
      AufteilEventDisabler.ExecuteExit() 'diverse Events erstmal abonnieren
   End Sub

End Class
