﻿Imports System.ComponentModel

Partial Class GrKassDts

   Partial Class KasseDataTable

      Public Sub Row_Changed(ByVal sender As Object, ByVal e As KasseRowChangeEvent) Handles Me.KasseRowChanged
         'Bei Dataset.AcceptChanges committen alle Rows. Dann wird hier der SignificantHash berechnet, aus den ersten 4 Spalten. Alle anderen Spalten sind für die Persistenz nicht signifikant, da entweder berechnet oder Hilfsspalten für die Anzeige der Beleg-Aufteilung 
         If e.Action <> DataRowAction.Commit Then Return
         With e.Row
            .SignificantHash = .CalculateSignificantHash()
         End With
      End Sub

      Public Sub Column_Changing(ByVal sender As Object, ByVal e As System.Data.DataColumnChangeEventArgs)
         Dim kasse = DirectCast(e.Row, KasseRow)
         Dim beleg = kasse.BelegRow
         If beleg.Null Then Return
         Dim posten = beleg.GetPostenRows.FirstOrDefault( _
            Function(p) p.IstAnteil AndAlso p.KasseID = kasse.KasseID)
         If e.Column Is columnHatAnteil Then
            If kasse.HatAnteil Then             'ggfs. PostenRow generieren oder löschen
               If posten.NotNull Then
                  Using DataSet.SuspendLogic
                     posten.Delete()
                     kasse.ClearAnteil()
                     kasse.Eigentum = False
                     beleg.Recalculate()
                  End Using
               End If
            Else
               If posten.Null Then
                  Me.Dts.Posten().AddPostenRow("", kasse.Self, beleg, 0, False)
               End If
            End If
         ElseIf e.Column Is columnEigentum Then
            Using DataSet.SuspendLogic
               If posten.Null Then
                  e.ProposedValue = False
               Else
                  posten.Eigentum = Not kasse.Eigentum 'Eigentum in der assoziierten PostenRow eintragen
               End If
            End Using
         End If
      End Sub

   End Class

   Partial Class KasseRow

      Public SignificantHash As Integer
      Public Function CalculateSignificantHash() As Integer
         Dim ret = 0
         For i = 0 To 3
            ret = ret Xor Me(i).GetHashCode
         Next
         Return ret
      End Function

      Public ReadOnly Property RejectsOwnership As Boolean
         Get
            Return Me.KontoNr < 0
         End Get
      End Property
      Public Sub SetAnteil(ByVal value As Decimal)
         HatAnteil = True
         Anteil = value
      End Sub
      Public Sub ClearAnteil()
         HatAnteil = False
         Anteil = 0D
      End Sub
   End Class

End Class
