﻿Imports GrKass.GrKassDts
Imports System.ComponentModel

Public Class DataPersistance

   Private Shared Function CheckNeedsSort(Of T As DataRow)(ByVal rows As IList(Of T), ByVal getID As Func(Of T, Integer)) As Boolean
      With rows.GetEnumerator
         If Not .MoveNext Then Return False
         Dim id = getID(.Current)
         While .MoveNext
            Dim id2 = getID(.Current)
            If id2 < id Then Return True
            id = id2
         End While
      End With
      Return False
   End Function

   Public Shared Sub LoadData()
      Dim dts = Program.DataSetSaver.DataSet
      Using dts.AufteilEventDisabler.Enter
         Program.DataSetSaver.Load()
         'Für die Tabellen Betreuer und Kasse sicherstellen, dass die ID-Reihenfolge der lexikalischen Sortierung der Namen entspricht. Dadurch ergibt die Sortierung einer auf diese Tabellen verweisenden DatagridviewComboboxColumn das Bild einer lexikalischen Sortierung.
         Dim betreuer = dts.Betreuer _
            .Select("", "BetreuerName", DataViewRowState.CurrentRows).Cast(Of BetreuerRow).ToList
         If CheckNeedsSort(betreuer, Function(rw) rw.BetreuerID) Then
            For Each rw In betreuer
               rw.BetreuerID -= 1000
            Next
            For i = 0 To betreuer.Count - 1
               betreuer(i).BetreuerID = i
            Next
         End If
         Dim kassen = dts.Kasse _
            .Select("KasseID>3", "KasseName", DataViewRowState.CurrentRows).Cast(Of KasseRow).ToList
         If CheckNeedsSort(kassen, Function(rw) rw.KasseID) Then
            For Each rw In kassen
               rw.KasseID -= 1000
            Next
            For i = 0 To kassen.Count - 1
               kassen(i).KasseID = i + 4
            Next
         End If
      End Using
      dts.AcceptChanges()
   End Sub

End Class
