﻿Imports System.IO
Imports GrKass.GrKassDts
Imports System.ComponentModel
Imports System.Text

Public Class frmAdmin

   Private _KasseFilterSource As New List(Of KeyValuePair(Of String, String))
   Private _Dts As GrKassDts = Program.DataSetSaver.DataSet
   Private WithEvents _Delay As New BusyDelay


   Public Sub New()
      InitializeComponent()
      For Each grd In NewArray(grdOverviewKasse, grdStueck, grdOverviewBetreuer, AufFuellungDataGridView)
         grd.InitAutoHeight()
      Next
      SplitContainer4.SplitterWidth = 8
      Me.Text = "Gruppenkasse ".And(_Dts.Settings(0).GruppeName, " - Admin")
      ControlBehavior.ActivateLockInfoMenu(btLockInfo)
      AddHandler grdOverviewBetreuer.CellPainting, ControlBehavior.GridHideZeroNegativeRed_CellPainting
      AddHandler grdStueck.CellPainting, ControlBehavior.GridHideZeroNegativeRed_CellPainting
      AddHandler grdKultur.CellPainting, ControlBehavior.GridNegativeRed_CellPainting
      AddHandler lbSaldoNeu.TextChanged, ControlBehavior.NumberControl_TextChanged
      AddHandler lbSumAktVorschuss.TextChanged, ControlBehavior.NumberControl_TextChanged
      AddHandler lbBarBestand.TextChanged, ControlBehavior.NumberControl_TextChanged
      'Beim Auftreten einer Differenz von berechnetem und gezählten Barbestand den gezählten rot darstellen. Also Settings.Difference an lbStueckSum.ForeColor binden, und im Format-Event des Bindings den Decimal-Wert nach Color konvertieren. 
      Dim bnd = New Binding("ForeColor", SettingsBindingSource, "Difference", True, DataSourceUpdateMode.Never)
      AddHandler bnd.Format, Sub(s, e) e.value = If(e.value.equals(0D), Color.Black, Color.Red)
      lbStueckSum.DataBindings.Add(bnd)
      AddHandler Program.DataSetSaver.IsLoadingChanged, AddressOf Data_LoadingChanged
      With UclAllBills1.PostenSource
         ' UclBillInput (=Belegeingabe) synchronisiert sich nach der PostenSource von AlleBelege
         AddHandler .CurrentChanged, AddressOf UclBillInput1.Synchronisize
      End With
      If _Dts.Settings.Count > 0 Then Data_LoadingChanged(Program.DataSetSaver, EventArgs.Empty)
   End Sub

   Private Sub MenuStrip_MenuClicked(ByVal Sender As Object, ByVal e As EventArgs) _
         Handles ReLoadToolStripMenuItem.Click, SaveToolStripMenuItem.Click, ZählhilfeToolStripMenuItem.Click, HilfeToolStripMenuItem.Click, TestToolStripMenuItem.Click, AutoVorgangToolStripMenuItem.Click
      Select Case True
         Case Sender Is ReLoadToolStripMenuItem
            DataPersistance.LoadData()

         Case Sender Is SaveToolStripMenuItem
            Program.DataSetSaver.SaveForm(Me)

         Case Sender Is ZählhilfeToolStripMenuItem
            Dim f = frmStueck
            If f.Visible Then f.BringToFront() Else f.Show(Me)

         Case Sender Is AutoVorgangToolStripMenuItem
            frmAutoVorgang.AutoVorgangDataGridView.DataSource = Program.Dts.AutoVorgang
            frmAutoVorgang.Show(Me)

         Case Sender Is HilfeToolStripMenuItem
            Process.Start("..\..\Other\Hilfe.rtf")

         Case Sender Is TestToolStripMenuItem
      End Select
   End Sub

   Protected Overrides Sub Dispose(ByVal disposing As Boolean)
      MyBase.Dispose(disposing)
      If disposing AndAlso components IsNot Nothing Then components.Dispose()
   End Sub

   Private Sub SettingsBindingSource_CurrentItemChanged(ByVal sender As Object, ByVal e As EventArgs) Handles SettingsBindingSource.CurrentItemChanged
      BusyDelay.SetCallback(UpdateGui)
   End Sub

   Private UpdateGui As Action = _
      Sub()
         With SettingsBindingSource.At(Of SettingsRow)()
            If .Null Then Return
            grpBetreuer.Text = "Handkassen           Ausgaben: ".And(.SumBelege.ToString("0.00#"), _
               "           Stand: ", .SumAktVorschuss.ToString("0.00#"))
            grpKassen.Text = "Kassen - Ausgaben: " & .SumKasse.ToString("0.00#")
            ckLock.Checked = .Locked
            SaveToolStripMenuItem.Enabled = Not .Locked
            btLockInfo.Visible = .Locked
         End With
      End Sub

   Private Sub grdOverviewKasse_CellPainting(ByVal sender As Object, ByVal e As DataGridViewCellPaintingEventArgs) Handles grdOverviewKasse.CellPainting
      'blauer Hintergrund für Klienten-Namen
      If e.Handled OrElse e.ColumnIndex <> 0 OrElse e.RowIndex < 0 Then Return
      Dim itm = grdOverviewKasse.Rows(e.RowIndex).DataBoundItem
      If itm Is Nothing Then Return
      Dim rw = DirectCast(DirectCast(itm, DataRowView).Row, KasseRow)
      If rw.RejectsOwnership Then Return
      If e.State.HasFlag(DataGridViewElementStates.Selected) Then Return 'Selection durchlassen
      Dim pp = DataGridViewPaintParts.All Xor (DataGridViewPaintParts.ContentBackground Or DataGridViewPaintParts.Background Or DataGridViewPaintParts.SelectionBackground)
      e.Graphics.FillRectangle(Brushes.AliceBlue, e.CellBounds)
      e.Paint(e.CellBounds, pp)
      e.Handled = True
   End Sub

   Private Sub Data_LoadingChanged(ByVal sender As Object, ByVal e As EventArgs)
      'Textboxen für Überträge sind direkt an die DataRow gebunden, keine BindingSource dazwischen. Denn Textbox-Eingaben per BindingSource führten bei Kultur nicht zur Aktualisierung der berechneten Spalten
      With _Dts
         If Program.DataSetSaver.IsLoading Then
            txtGesamtSaldo0.DataBindings.Remove("Text")
            txtKulturSaldo0.DataBindings.Remove("Text")
         Else
            txtGesamtSaldo0.DataBindings.Add("Text", .Settings(0), "Saldo0")
            txtKulturSaldo0.DataBindings.Add("Text", .Kasse(1), "Saldo0")
         End If
      End With
   End Sub

   Private Sub ckLock_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ckLock.Click
      With Program.Dts.Settings(0)
         .Locked = Not .Locked
         If .Locked Then Program.DataSetSaver.SaveForm(Me)
      End With
   End Sub
End Class
