﻿Imports System.ComponentModel

<DesignerCategory("Code")> _
Public Class LockColumnGrid : Inherits DataGridView

   Private _nextCell As DataGridViewCell
   Private _runLeft As Boolean
   Private _byTab As Boolean

   <Description("defines the direction, where to look for an unlocked column first")> _
   Public Property FirstRunLeft As Boolean

   Protected Overrides Sub OnKeyDown(ByVal e As System.Windows.Forms.KeyEventArgs)
      _byTab = e.KeyCode = Keys.Tab
      _runLeft = e.KeyData = (Keys.Tab Or Keys.Shift) OrElse e.KeyData = Keys.Left
      MyBase.OnKeyDown(e)
   End Sub

   Protected Overrides Sub OnCellEnter(ByVal e As System.Windows.Forms.DataGridViewCellEventArgs)
      MyBase.OnCellEnter(e)
      Dim x = e.ColumnIndex
      If Not Columns(x).ReadOnly Then
         _runLeft = FirstRunLeft
         Return
      End If
      Dim y = e.RowIndex
      Try
         Dim ext = _runLeft
         Do
            If _runLeft Then
               For x = x - 1 To 0 Step -1
                  If Columns(x).Visible AndAlso Not Columns(x).ReadOnly Then Return
               Next
            Else
               For x = x + 1 To Me.ColumnCount - 1
                  If Columns(x).Visible AndAlso Not Columns(x).ReadOnly Then Return
               Next
            End If
            If _byTab Then 'zeilenwechsel
               If _runLeft Then
                  If y > 0 Then
                     y -= 1
                     x = ColumnCount - 1
                     Continue Do
                  End If
               Else
                  If y < RowCount - 1 Then
                     y += 1
                     x = 0
                     Continue Do
                  End If
               End If
            End If
            'nix gefunden - richtungswechsel
            _runLeft = Not _runLeft
            x = e.ColumnIndex
         Loop Until ext = _runLeft
      Finally
         _nextCell = Me(x, y)
         If Not _nextCell.Visible Then Dim i = 9
         AddHandler Application.Idle, AddressOf App_Idle
         _runLeft = FirstRunLeft
         _byTab = False
      End Try
      Return
   End Sub

   Private Sub App_Idle(ByVal sender As Object, ByVal e As EventArgs)
      RemoveHandler Application.Idle, AddressOf App_Idle
      MyBase.CurrentCell = _nextCell
   End Sub

End Class
