﻿Imports GrKass.GrKassDts
Imports System.Text

Public Class uclAllBills

   Private _sBetreuerFilter As String = ""
   Private _KasseFilterSource As New List(Of KeyValuePair(Of String, String))
   Private _GroupColumnIndex, _GroupHeaderHeight, _StandardHeight As Integer

   Private _EventDisabler As New ActionFrame( _
         Sub()
            RemoveHandler PostenSource.PositionChanged, AddressOf PostenSource_CurrentChanged
            RemoveHandler FK_Beleg_PostenSource.CurrentChanged, AddressOf PostenSource_CurrentChanged
         End Sub, _
         Sub()
            AddHandler PostenSource.PositionChanged, AddressOf PostenSource_CurrentChanged
            AddHandler FK_Beleg_PostenSource.CurrentChanged, AddressOf PostenSource_CurrentChanged
         End Sub)

   Private Sub PostenSource_CurrentChanged(ByVal sender As Object, ByVal e As EventArgs)
      'synchronisiere die beiden Views auf dieselbe PostenRow
      With DirectCast(sender, BindingSource)
         If .Position < 0 Then Return
         Using _EventDisabler.Enter
            Me.components.SynchronisizeSources(.At(Of PostenRow))
         End Using
      End With
   End Sub

   Public Sub New()
      InitializeComponent()
      _GroupColumnIndex = 1
      _StandardHeight = grdAllePosten.RowTemplate.Height
      _GroupHeaderHeight = (_StandardHeight * 4) \ 3
      Dim col = BelegBetreuerColumn
      SplitContainer7.SplitterWidth = 8
      AddHandler grdBelegPosten.CellPainting, AddressOf ControlBehavior.PostenGrid_CellPainting
      AddHandler KasseSource.ListChanged, Sub(s, e) UpdateKasseFilterSource()
      Dim setFilter = Sub(s As Object, e As EventArgs) SetKasseFilter()
      AddHandler cmbKasseFilter.SelectedIndexChanged, setFilter
      AddHandler ckFilterEigentum.CheckedChanged, setFilter
      AddHandler grdAllePosten.ColumnHeaderMouseClick, AddressOf grdAllePosten_ColumnHeaderMouseClick
      _EventDisabler.ExecuteExit() 'subscribe events
      SetSortOrder(1)
   End Sub

   Public Sub SetBetreuer(ByVal betreuerID As Integer)
      _sBetreuerFilter = " AND BetreuerID=" & betreuerID
      BelegBindingSource.Filter = "BetreuerID=" & betreuerID
      BelegBetreuerColumn.Visible = False
      PostenBetreuerColumn.AutoSizeMode = DataGridViewAutoSizeColumnMode.None
      PostenBetreuerColumn.Width = 0
      UpdateKasseFilterSource()
      SetKasseFilter()
      NewArray(Of DataGridViewColumn)(KasseColumn, BelegIDColumn).ForEach(Sub(col)  col.ToolTipText = "")
      RemoveHandler grdAllePosten.ColumnHeaderMouseClick, AddressOf grdAllePosten_ColumnHeaderMouseClick
   End Sub

   Private Sub UpdateKasseFilterSource()
      _KasseFilterSource.Clear()
      _KasseFilterSource.Add(NewKeyValue("Alle", "Betrag<>0" & _sBetreuerFilter))
      _KasseFilterSource.AddRange(Program.DataSetSaver.DataSet.Kasse.All.Select( _
         Function(rw) NewKeyValue(rw.KasseName, "Betrag<>0 AND KasseID=" & rw.KasseID & _sBetreuerFilter)))
      With cmbKasseFilter
         .DisplayMember = "Key"
         .ValueMember = "Value"
         .DataSource = _KasseFilterSource
      End With
   End Sub

   Private Sub SetKasseFilter()
      If cmbKasseFilter.SelectedIndex < 0 Then Return
      Dim s = _KasseFilterSource(cmbKasseFilter.SelectedIndex).Value
      If ckFilterEigentum.Checked Then s &= " And Eigentum"
      PostenSource.Filter = s
   End Sub

   Private _SortOrders As Dictionary(Of String, String) = NewDictionary(
      NewKeyValue("BelegID", "BelegID, IstAnteil desc, KasseID"),
      NewKeyValue("KasseID", "KasseID, BetreuerID, BelegID"),
      NewKeyValue("BetreuerID", "BetreuerID, BelegID, IstAnteil desc, KasseID"))

   Private Sub grdAllePosten_ColumnHeaderMouseClick(ByVal sender As Object, ByVal e As DataGridViewCellMouseEventArgs)
      SetSortOrder(e.ColumnIndex)
   End Sub

   Private Sub SetSortOrder(ByVal indx As Integer)
      Dim col = grdAllePosten.Columns(indx)
      If Not _SortOrders.ContainsKey(col.DataPropertyName) Then Return
      BelegSumColumn.Visible = col.DataPropertyName <> "KasseID"
      _GroupColumnIndex = indx
      Using _EventDisabler.Enter
         Dim sort = _SortOrders(col.DataPropertyName)
         Dim sorts = sort.Split(",").ToList
         Dim props = BelegBindingSource.GetItemProperties(Nothing)
         For i = sorts.Count - 1 To 0 Step -1
            If props.Find(sorts(i).Replace("desc", ""), True).Null Then sorts.RemoveAt(i)
         Next
         BelegBindingSource.Sort = sorts.Join(",")
         PostenSource.Sort = sort
         FK_Beleg_PostenSource.Sort = sort
      End Using
      KasseSumColumn.Visible = Not BelegSumColumn.Visible
      PostenSource_CurrentChanged(PostenSource, EventArgs.Empty) 'synchronisize
   End Sub

   Private Sub grdPosten_CellPainting(ByVal sender As Object, ByVal e As DataGridViewCellPaintingEventArgs) Handles grdAllePosten.CellPainting
      If e.ColumnIndex < 0 OrElse e.RowIndex < 0 Then Return
      Dim grd = DirectCast(sender, DataGridView)
      Dim col = grdAllePosten.Columns(e.ColumnIndex)
      If col.DataPropertyName = "Eigentum" Then
         Dim rw = DirectCast(DirectCast(grd.Rows(e.RowIndex).DataBoundItem, DataRowView).Row, PostenRow)
         If rw.KasseRow.RejectsOwnership Then
            ' Zeichnung der Checkbox unterdrücken bei Kassen, die nicht Eigentümer sein können
            Dim pp = e.PaintParts And (DataGridViewPaintParts.ContentForeground Xor -1)
            e.Paint(e.CellBounds, DirectCast(pp, DataGridViewPaintParts))
            e.Handled = True
         End If
         Return
      End If
      'je nach sortierung können gleiche Werte als Gruppe kenntlich gemacht werden, indem der Wert nur einmal angezeigt wird, die darunter liegenden (gleichen) Einträge werden unterdrückt.
      Select Case PostenSource.Sort.Substring(0, 7)
         Case "BelegID"
            If "BelegID BetreuerID".Contains(col.DataPropertyName) _
              AndAlso Not IsGroupHeader(1, e.RowIndex) Then HideValue(e)
         Case "KasseID"
            If col.DataPropertyName = "KasseID" _
              AndAlso Not IsGroupHeader(e.ColumnIndex, e.RowIndex) Then HideValue(e)
         Case "Betreue"
            If "BelegID BetreuerID".Contains(col.DataPropertyName) _
              AndAlso Not IsGroupHeader(e.ColumnIndex, e.RowIndex) Then HideValue(e)
      End Select
   End Sub

   Private Sub HideValue(ByVal e As DataGridViewCellPaintingEventArgs)
      Dim pp = e.PaintParts And (DataGridViewPaintParts.Background Or DataGridViewPaintParts.ContentBackground Or DataGridViewPaintParts.Focus Or DataGridViewPaintParts.SelectionBackground)
      e.Paint(e.ClipBounds, pp)
      e.Handled = True
   End Sub

   Private Function IsGroupHeader(ByVal groupColumnIndex As Integer, ByVal rowIndex As Integer) As Boolean
      'GroupHeader sind PostenRows, deren Spaltenwert der GroupColumn sich vom Wert des vorherigen Postens unterscheidet
      Return rowIndex = 0 OrElse Not Object.Equals(grdAllePosten(groupColumnIndex, rowIndex).Value, grdAllePosten(groupColumnIndex, rowIndex - 1).Value)
   End Function

   Private Sub grdAllePosten_RowPostPaint(ByVal sender As Object, ByVal e As DataGridViewRowPostPaintEventArgs) Handles grdAllePosten.RowPostPaint
      'GroupHeader durch rote Linie hervorheben
      If e.RowIndex < 1 OrElse Not IsGroupHeader(_GroupColumnIndex, e.RowIndex) Then Return
      With e.RowBounds
         e.Graphics.DrawLine(Pens.Red, _
            New Point(0, .Y + 3), New Point(.Right, .Y + 3))
      End With
   End Sub

   Private Sub grdAllePosten_RowPrePaint(ByVal sender As Object, ByVal e As DataGridViewRowPrePaintEventArgs) Handles grdAllePosten.RowPrePaint
      'GroupHeader durch größere RowHeight hervorheben
      If e.RowIndex < 1 Then Return
      grdAllePosten.Rows(e.RowIndex).Height _
         = If(IsGroupHeader(_GroupColumnIndex, e.RowIndex), _GroupHeaderHeight, _StandardHeight)
   End Sub

   Private Sub grdBelegPosten_CellBeginEdit(ByVal sender As Object, ByVal e As DataGridViewCellCancelEventArgs) Handles grdBelegPosten.CellBeginEdit
      'If e.ColumnIndex <> 2 Then Return
      If FK_Beleg_PostenSource.At(Of PostenRow)().IstAnteil Then
         With New StringList
            .AddLine("Anteilig berechnete Posten können hier nicht geändert werden.")
            .AddLine()
            .AddLine("Benutzen Sie die Beleg-Eingabe")
            MsgBox(.ToString, MsgBoxStyle.Information, "Eingabe verweigert")
         End With
         e.Cancel = True
      End If
   End Sub

End Class
