﻿Imports System.ComponentModel
Imports GrKass.GrKassDts
Imports System.Windows.Forms

Public Class uclBillInput

   Private ReadOnly Property Dts As GrKassDts
      Get
         Return Program.DataSetSaver.DataSet
      End Get
   End Property

   Public Sub New()
      InitializeComponent()
      grdAufteil.InitAutoHeight()
      grdAufteil.InitLockColumns().FirstRunLeft = True
      grdMoney.InitAutoHeight()
      AddHandler lbKultur.TextChanged, ControlBehavior.NumberControl_TextChanged
      AddHandler lbVorschussSaldo1.TextChanged, ControlBehavior.NumberControl_TextChanged
      AddHandler grdIndividuell.CellPainting, AddressOf ControlBehavior.PostenGrid_CellPainting
   End Sub

   'behandelt ein externes Bindingsource.CurrentChanged. stellt die Hierarchie meiner Bindingsources so ein, dass die .Current der sender-BindingSource ebenfalls angezeigt wird.
   Public Sub Synchronisize(ByVal sender As Object, ByVal e As EventArgs)
      Dim rw = DirectCast(sender, BindingSource).At(Of PostenRow)()
      If rw.Null Then Return
      Me.components.SynchronisizeSources(rw)
   End Sub

   Private Sub grdAufteil_CellPainting(ByVal sender As Object, ByVal e As DataGridViewCellPaintingEventArgs) Handles grdAufteil.CellPainting
      If e.Handled OrElse e.ColumnIndex < 0 OrElse e.RowIndex < 0 Then Return
      Dim grd = DirectCast(sender, DataGridView)
      Dim itm = grd.Rows(e.RowIndex).DataBoundItem
      If itm Is Nothing Then Return
      Dim rw = DirectCast(DirectCast(itm, DataRowView).Row, KasseRow)
      Select Case grd.Columns(e.ColumnIndex).DataPropertyName
         Case "Eigentum"
            If Not rw.RejectsOwnership Then Return
            ' Zeichnung der Checkbox unterdrücken bei Kassen, die nicht Eigentümer sein können
            Dim mask = DataGridViewPaintParts.All Xor DataGridViewPaintParts.ContentForeground
            e.Paint(e.CellBounds, e.PaintParts And mask)
         Case "KasseName"
            If rw.RejectsOwnership Then Return
            'Kassen, die Eigentümer sein können, blau hinterlegen
            If e.State.HasFlag(DataGridViewElementStates.Selected) Then Return 'Selection durchlass1en
            Dim mask = DataGridViewPaintParts.All Xor DataGridViewPaintParts.ContentBackground Or DataGridViewPaintParts.Background Or DataGridViewPaintParts.SelectionBackground
            e.Graphics.FillRectangle(Brushes.AliceBlue, e.CellBounds)
            e.Paint(e.CellBounds, e.PaintParts And mask)
         Case Else
            ControlBehavior.GridHideZeroNegativeRed_CellPainting(sender, e)
            Return
      End Select
      e.Handled = True
   End Sub

   Protected Overrides Sub Dispose(ByVal disposing As Boolean)
      MyBase.Dispose(disposing)
      If disposing AndAlso components IsNot Nothing Then components.Dispose()
   End Sub

   Private Sub splBelege_Validating(ByVal sender As Object, ByVal e As CancelEventArgs) Handles splBelege.Validating
      If e.Cancel Then Return
      e.Cancel = Program.DataSetSaver.DataSet.HasErrors
      If e.Cancel Then MsgBox("Korrigieren Sie bitte die Eingaben", MsgBoxStyle.OkOnly, "Eingabefehler")
   End Sub

   Private Sub grdAufteil_CellContentClick(ByVal sender As Object, ByVal e As DataGridViewCellEventArgs) Handles grdAufteil.CellContentClick
      If e.ColumnIndex <> 0 Then Return
      'Klick auf eine Kasse-Checkbox sofort ins Dataset übernehmen - nicht erst auf Wechsel des Datensatzes warten. Das löst eine Neuberechnung der Aufteilung aus.
      grdAufteil.EndEdit()
      KasseBindingSource.EndEdit()
   End Sub

   Private Sub BelegBindingSource_CurrentChanged(ByVal sender As Object, ByVal e As EventArgs) Handles BelegBindingSource.CurrentChanged
      'stellt die temporären Spalten aller Kassen auf den aktuellen Beleg ein
      Using Dts.AufteilEventDisabler.Enter
         Dim beleg = BelegBindingSource.At(Of BelegRow)()
         For Each ks In Dts.Kasse.All 'BelegRow einstellen und alte Werte löschen
            ks.BelegRow = beleg
            ks.ClearAnteil()
            ks.Eigentum = False
         Next
         If beleg.Null Then Return
         'Daten der anteiligen PostenRows in die temp Spalten laden
         For Each pst In beleg.GetPostenRows.Where(Function(p) p.IstAnteil)
            pst.KasseRow.SetAnteil(pst.Betrag)
            pst.KasseRow.Eigentum = pst.Eigentum
         Next
      End Using
   End Sub

   Private Sub grdIndividuell_CellEndEdit(ByVal sender As Object, ByVal e As DataGridViewCellEventArgs) Handles grdIndividuell.CellEndEdit
      'Eingabe eines Betrages in eine detachte Zeile sofort übernehmen
      If e.ColumnIndex <> 0 OrElse e.RowIndex <> grdIndividuell.RowCount - 2 Then Return
      Dim rw = FixPostenSource.At(Of PostenRow)(e.RowIndex)
      If rw.Null OrElse rw.RowState <> DataRowState.Detached Then Return
      FixPostenSource.EndEdit()
   End Sub
End Class