﻿Imports System.IO
Imports GrKass.GrKassDts
Imports System.ComponentModel
Imports System.Runtime.InteropServices
Imports System.Reflection
Imports System.Text

Public Module Program

   Public ReadOnly DataSetSaver As New DataSetSaver(Of GrKassDts) With {.DataFile = "..\..\Other\GrKassDts.txt"}
   Public ReadOnly Dts As GrKassDts = DataSetSaver.DataSet


   <STAThread()> _
   Public Sub Main(ByVal commandLineArgs As String())
      Application.EnableVisualStyles()
      Application.SetCompatibleTextRenderingDefault(False)
      DataSetSaver.HasChanges = AddressOf DataSetSaver.DataSet.HasChanges

      Dim sw = Stopwatch.StartNew
      'DataPersistance.LoadData()
      'Application.Run(DataSetSaver.CreateForm(Of Form1))
      'Return

      Dim frm As Form = Nothing
      If Not File.Exists(DataSetSaver.DataFile) Then
         With New StringList
            .AddLine("Das DatenFile konnte nicht gefunden werden:")
            .AddLine()
            .AddLine(System.IO.Path.GetFullPath(DataSetSaver.DataFile))
            .AddLine()
            .AddLine("Ohne DatenFile ist das Programm nicht lauffähig.")
            MsgBox(.ToString, MsgBoxStyle.Exclamation, "Sorry - Programm nicht lauffähig")
         End With
         Return
      End If
      DataPersistance.LoadData()
      Dbg(sw.ElapsedMilliseconds)
      Using frmLog = DataSetSaver.CreateForm(Of LogIn)()
         With frmLog
            '.StartAsAdmin = True
            If .ShowDialog <> Windows.Forms.DialogResult.OK Then Return
            If .StartAsAdmin OrElse Dts.Betreuer.Count = 0 Then
               frm = DataSetSaver.CreateForm(Of frmAdmin)()
            Else
               Dim User = .BetreuerBindingSource.At(Of BetreuerRow)()
               Dim frmU = DataSetSaver.CreateForm(Of frmUser)()
               frmU.UclBillInput1.BetreuerBindingSource.Filter = "BetreuerID=" & User.BetreuerID
               frm = frmU
            End If
         End With
      End Using
      Dbg(sw.ElapsedMilliseconds)
      ControlBehavior.InitGrids(frm)
      Dbg(sw.ElapsedMilliseconds)
      Application.Run(frm)
      My.Settings.Save()
   End Sub

End Module
